#include "tcp_server_demo.h"
#include "lwip/opt.h"
#include "lwip_comm.h"
#include "led.h"
#include "lwip/lwip_sys.h"
#include "lwip/api.h"
#include "usr_infor.h"
#include "base64.h"
#include "malloc.h"
#include "protohandle.h"
#include "sram.h"
#include "main.h"



DataPack pack;

#if _USE_MBOX//
extern OS_EVENT *mbox; 
#endif

#if _USE_QUE
extern OS_EVENT *que;
#endif


//tcp
void tcp_server_thread(void *arg)
{
	OS_CPU_SR cpu_sr;
	u8 tcp_server_recv[TCP_SERVER_RX_BUFSIZE];	//TCPͻ˽ݻ
	u32 data_len = 0;
	struct pbuf *q;
	err_t err,recv_err;
	u8 remot_addr[4];
	struct netconn *conn, *newconn;
	static ip_addr_t ipaddr;
	static u16_t 			peer_local;
	u16_t local_serv_port = 8088;// default
	

	char *pb = NULL;
	size_t n;
	INT8U error;
	
	LWIP_UNUSED_ARG(arg);
	
	local_serv_port = getLocalPort(LOCAL_ETC_ADDR);//ȡFlash 豸
	printf("local server port = %d\r\n",local_serv_port);
	conn = netconn_new(NETCONN_TCP);  //һTCP
	
	netconn_bind(conn,IP_ADDR_ANY,local_serv_port);  //󶨶˿8088Ŷ˿
	
	
	netconn_listen(conn);  //ģʽ
	conn->recv_timeout = 10;  //ֹ߳ ȴ10ms
	printf("ʼ߳\r\n");
	
	
	while (1) 
	{
		err = netconn_accept(conn,&newconn);  //
		newconn->recv_timeout = 10;
		memset(tcp_server_recv,0,TCP_SERVER_RX_BUFSIZE);
		
		if (err == ERR_OK)    //ӵ
		{ 
			struct netbuf *recvbuf;

			// 
			netconn_getaddr(newconn,&ipaddr,&peer_local,0); //ȡԶIPַͶ˿ں
			
			remot_addr[3] = (uint8_t)(ipaddr.addr >> 24); // ͻ˵IPַ
			remot_addr[2] = (uint8_t)(ipaddr.addr>> 16);
			remot_addr[1] = (uint8_t)(ipaddr.addr >> 8);
			remot_addr[0] = (uint8_t)(ipaddr.addr);
			printf("%d.%d.%d.%dϷ,˿ںΪ:%d\r\n",remot_addr[0], remot_addr[1],remot_addr[2],remot_addr[3],peer_local);
			
			
			while(1)
			{
				
				if((recv_err = netconn_recv(newconn,&recvbuf)) == ERR_OK)  	//յ
				{		
					OS_ENTER_CRITICAL(); //ж
					memset(tcp_server_recv,0,TCP_SERVER_RX_BUFSIZE);  //ݽջ
		
					
					for(q=recvbuf->p; q!=NULL; q=q->next)  //pbuf
					{
						//жҪTCP_SERVER_RX_BUFSIZEеǷTCP_SERVER_RX_BUFSIZEʣռ䣬
						//ĻֻTCP_SERVER_RX_BUFSIZEʣ೤ȵݣĻͿе
						if(q->len > (TCP_SERVER_RX_BUFSIZE-data_len)) 
							memcpy(tcp_server_recv+data_len,q->payload,(TCP_SERVER_RX_BUFSIZE-data_len));//
						else 
							memcpy(tcp_server_recv+data_len,q->payload,q->len);
						data_len += q->len;  	
						if(data_len > TCP_SERVER_RX_BUFSIZE) 
							break; //TCPͻ˽,	
					}	
					data_len=0;  //ɺdata_lenҪ	
					OS_EXIT_CRITICAL();  //ж
					// base64 decoder
					// check <cmd>
					// unpacket
					//respose     Ҫһ
					printf("before decoder:%s\r\n",tcp_server_recv);  //ͨڷͽյ
					printf("strlen((char *)tcp_server_recv) = %d\r\n",strlen((char *)tcp_server_recv));

					pb = decode_base64((const char*)tcp_server_recv,&n);
					
					if(pb != NULL)
					{
							printf("After decoder:%s\r\n",pb);
						  printf("strlen(pb) = %d\r\n",n);
						
							if(pb[0] !='<' || pb[1] !='c' || pb[2] !='m' || pb[3] !='d' || pb[4] !='>')
							{
									printf("recv a unknow stream\r\n");
							}
							else
							{
									printf("Begin Process\r\n");
									
									OS_ENTER_CRITICAL(); //ж
									UnPackData1(pb,&pack);
									OS_EXIT_CRITICAL();  //ж
									
									#if _USE_MBOX
									error = OSMboxPostOpt(mbox,(void *)&pack,OS_POST_OPT_BROADCAST);
									//error = OSMboxPostOpt(mbox,&pack,OS_POST_OPT_NONE);
									if(error == OS_ERR_NONE)
										printf("Send MBox success\r\n");
									else if(error == OS_ERR_MBOX_FULL)
										printf("MBox is full\r\n");
									else if(error == OS_ERR_PEVENT_NULL)
										printf("Mbox mbox == NULL\r\n");
									else if(error == OS_ERR_POST_NULL_PTR)
										printf("Mbox msg == NULL\r\n");
									// 
									//OSTaskSuspend(DECODE_USART_TASK_PRO);
									//OSTaskSuspend(MAN_IDENTIFY_TASK_PRIO);
									//OSTaskSuspend(UDISK_TASK_PRIO);
									//OSTaskSuspend(GET_TIME_TASK_PRO);
								  #endif
									
									#if _USE_QUE
									error = OSQPost(que,(void *)&pack);
									if(error == OS_ERR_PEVENT_NULL)
										printf("OS_ERR_PEVENT_NULL\r\n");
									else if(error == OS_ERR_EVENT_TYPE)
										printf("OS_ERR_EVENT_TYPE\r\n");
									else if(error == OS_ERR_Q_FULL)
										printf("OS_ERR_Q_FULL\r\n");
									#endif
									OS_ENTER_CRITICAL(); //ж
									printf("unpack ok\r\n");
									printf("datapack.type=%d\r\n",pack.type);
									OS_EXIT_CRITICAL();  //ж
									//OSTimeDlyHMSM(0,0,0,100);				
									#if !(_USE_QUE && USE_MBOX)
									ProtolResponse1(&pack);
									#endif
														
							}
						
							myfree(SRAMIN,pb);
							break;
					}
					else
					{
							printf("failed : Decoder heap\r\n");
							break;
					}
					
					netbuf_delete(recvbuf);
				}
				else if(recv_err == ERR_CLSD)  //ر
				{				
					netconn_close(newconn);
					netconn_delete(newconn);
					printf(":%d.%d.%d.%dϿ\r\n",remot_addr[0], remot_addr[1],remot_addr[2],remot_addr[3]);
					break;
				}
			}
			OSTimeDlyHMSM(0,0,0,100);
		}
	}                  // end while(1)
	
}

/****************************************


TCPͻ   
ͻ˲SERVݣͻ  Ͽ  
ͻ˸SEVRݣͻ  Ͽ   ֮󣬰ӳ
ݴڴӡϢֻܿ ͻ      ͻ Ͽ 

******************************************/


/***************************************************************************************************************
	
					if(tcp_server_recv[0] != '<' || tcp_server_recv[1] != 'c' || tcp_server_recv[2] != 'm' ||
						tcp_server_recv[3] != 'd' || tcp_server_recv[4] != '>')
					{
						printf("RECV a unKown String\r\n");
					}
					else
					{
							printf("Begin Process\r\n");
							
							UnPackData1((char *)tcp_server_recv,&pack);
							
							printf("unpack ok\r\n");
							printf("datapack.type=%d\r\n",pack.type);
														
							//ProtolResponse1(&pack);
					}
**************************************************************************************************************/
